type Ptr = ^RowType;
     RowType = record x:integer; next:Ptr; end;
     ColType = record x1,x2:integer; end;

var Col:array[1..1000] of ColType; { Balts rtias kolonns }
    Row:array[1..1000] of Ptr;	   { Balts rtias rinds   }
    RowCount,Sol:array[1..1000] of integer;
    { RowCount[i] - i-ts rindas pieaujamo rtiu skaits.
      Sol[i] - atrisinjums, i-taj kolonn jauj Sol[i] rindas rtia }
    c,r,k:integer; { c - kolonnu skaits; r - rindu skaits }
    NoSol:boolean;

procedure ReadInput;
var i:integer; t:Ptr;
begin
     ReadLn(r,c); for i:=1 to r do begin Row[i]:=nil; RowCount[i]:=0; end;
     for i:=1 to c do
         begin
              ReadLn(Col[i].x1,Col[i].x2);
              New(t); t^.x:=i; t^.next:=Row[Col[i].x1]; Row[Col[i].x1]:=t;
              New(t); t^.x:=i; t^.next:=Row[Col[i].x2]; Row[Col[i].x2]:=t;
              Inc(RowCount[Col[i].x1]); Inc(RowCount[Col[i].x2]);
         end;
end;

procedure Find(lim:integer);
var i,cr,cc:integer; t:Ptr;
begin
     for i:=1 to r do
         if RowCount[i]<=lim
         then begin
                   cr:=i;
                   while RowCount[cr]<=lim do
                         begin
                              if RowCount[cr]=0
                              then begin NoSol:=True; Exit; end;
                              RowCount[cr]:=MaxInt;
                              t:=Row[cr];
                              while Sol[t^.x]<>0 do t:=t^.next;
                              cc:=t^.x;
                              Sol[cc]:=cr;
                              if Col[cc].x1=cr
                              then cr:=Col[cc].x2
                              else cr:=Col[cc].x1;
                              Dec(RowCount[cr]);
                         end;
              end;
end;

procedure Compute;
var i:integer;
begin
     FillChar(Sol,SizeOf(Sol),0);
     NoSol:=False;
     Find(1); { aujam rinds, kurs ir tikai viena pieaujam rtia }
     if not NoSol
     then begin
               Find(1000); { aujam prjs rinds }
	       { aujam nesaauts kolonnas }	
               for i:=1 to c do if Sol[i]=0 then Sol[i]:=Col[i].x1;
          end;
end;

procedure WriteOutput;
var i:integer;
begin
     if NoSol
     then WriteLn('NO')
     else begin for i:=1 to c-1 do Write(Sol[i],' '); WriteLn(Sol[c]); end;
end;

begin
     Assign(input,'sho.in'); Reset(input);
     Assign(output,'sho.out'); Rewrite(output);
     ReadLn(k);
     while k<>0 do
           begin
                ReadInput;
                Compute;
                WriteOutput;
                Dec(k);
           end;
     Close(input); Close(output);
end.
