program meistardesas;

{$IFDEF WINDOWS} uses WinCrt; {$ELSE} uses Crt; {$ENDIF}

const
 nekor = 'NAV KOREKTS DESU PROTOKOLS.';
 nepab = 'DESAS NAV PABEIGTAS.';
 x = 4;
 o = 1;
 t = 0;

var
 s : string; {virkne, kuru ievada}
 a : array [1..9] of byte;
 i,j,beidza : byte;
 aizn : array [o..x,1..5] of shortint;  {aizn[k,l] norda, kur viet atrodas l-tais simbols k}
 skaits : array [o..x] of shortint;    {saskaitam, cik o un x ir}

function PARB_DESU(vert:byte):boolean;
 begin
  PARB_DESU := true;
  if a[1]+a[2]+a[3]=vert then Exit;
  if a[4]+a[5]+a[6]=vert then Exit;
  if a[7]+a[8]+a[9]=vert then Exit;
  if a[1]+a[4]+a[7]=vert then Exit;
  if a[2]+a[5]+a[8]=vert then Exit;
  if a[3]+a[6]+a[9]=vert then Exit;
  if a[1]+a[5]+a[9]=vert then Exit;
  if a[3]+a[5]+a[7]=vert then Exit;
  PARB_DESU := false;
 end;

function POT_DESA(m:byte):boolean;
 begin
  POT_DESA := PARB_DESU(2*m);
 end;

function IR_DESA(m:byte):boolean;
 begin
  IR_DESA := PARB_DESU(3*m);
 end;

function NOGRAUZ(oskaits,xskaits,kam_gaj : byte): word;
var summa : word;
     i : byte;
    bija : boolean;
 begin
  if (oskaits=2) and (xskaits=2) then begin NOGRAUZ:=4; Exit; end;
  summa := 0;
  case kam_gaj of
   o : for i:=1 to 5 do
        if aizn[o,i]>0
         then
          begin
           bija := IR_DESA(o);
           a[aizn[o,i]] := t;
           aizn[o,i] := -aizn[o,i];
           if (bija and (not IR_DESA(o))) or ((not bija) and (not POT_DESA(o)))
            then Inc(summa,NOGRAUZ(oskaits-1,xskaits,x));
           aizn[o,i] := -aizn[o,i];
           a[aizn[o,i]] := o;
          end;
   x : for i:=1 to 5 do
        if aizn[x,i]>0
         then
          begin
           bija := IR_DESA(x);
           a[aizn[x,i]] := t;
           aizn[x,i] := -aizn[x,i];
           if (bija and (not IR_DESA(x))) or ((not bija) and (not POT_DESA(x)))
            then Inc(summa,NOGRAUZ(oskaits,xskaits-1,o));
           aizn[x,i] := -aizn[x,i];
           a[aizn[x,i]] := x;
          end;
  end; {case}
  NOGRAUZ := summa;

 end;


begin
 Write('Ievadiet prbaudmo virkni ! =>'); readln(s);
 if Length(s)<>9 then begin writeln(nekor); Exit; end;
 {Prkodjam}
 for i:=t to x do skaits[i] := 0;
 for i:=o to x do for j:=1 to 5 do aizn[i,j] := 0;
 for i:=1 to 9 do
  case s[i] of
   'O':begin
        a[i] := o;
        Inc(skaits[o]);
        if skaits[o]>5 {viena veida nevar bt vairk par 5 gab.}
         then begin writeln(nekor); Exit; end
         else aizn[o,skaits[o]]:=i;
       end;
   'X':begin
        a[i] := x;
        Inc(skaits[x]);
        if skaits[x]>5 {viena veida nevar bt vairk par 5 gab.}
         then begin writeln(nekor); Exit; end
         else aizn[x,skaits[x]]:=i;
       end;
   'T':a[i] := t;
   else begin writeln(nekor); Exit; end {nedergs simbols virkn}
  end; {case}
 if abs(skaits[o]-skaits[x])>1 then begin writeln(nekor); Exit; end; {skaits nevar atirties vairk k par 1}
 if IR_DESA(o)
  then
   if IR_DESA(x)
    then
     begin writeln(nekor); Exit; end {Nevar vienlaicgi bt desas abiem}
    else  {o desa}
     if (skaits[o]-skaits[x]) < 0
      then begin writeln(nekor); Exit; end {o desa pc x gjiena}
      else beidza := o
  else
   if IR_DESA(x)
    then  {x desa}
     if (skaits[x]-skaits[o]) < 0
      then begin writeln(nekor); Exit; end {x desa pc o gjiena}
      else beidza := x
    else {Nevienam nav desa}
     if skaits[o]+skaits[x]<9
      then begin writeln(nepab); Exit; end
      else
       if skaits[o]>skaits[x]
        then beidza := o
        else beidza := x;

  {Jatrisina uz "MEISTARBU"}

  writeln('PROTOKOLAM ATBILST ',NOGRAUZ(skaits[o],skaits[x],beidza),' MEISTARVARIANTI.');

end.