program parbaudi_vai_Armstrongs;
{No klaviatras ievadtai ciparu virknei prbauda,
 vai tas ir Armstronga skaita pieraksts.

 Katru ievadto skaitli izvieto "skaitlis" tipa maingaj.

 Realiztas nepiecieams aritmtisks funkcijas.

 Rezultts tiek izvadts uz monitora.

  Mrti Opmanis , 1996.
 }

uses {$IFDEF WINDOWS} WinCrt {$ELSE} Crt {$ENDIF};

type
 skaitlis = array [1..3] of longint;

const
 sk_0 : skaitlis = (0,0,0);
 max_garums = 20;

var
 armstr_string, s_rez : string;

procedure Normalize(var sk : skaitlis);
var i:byte;
 begin
  for i:=1 to 2 do
   if sk[i]>9999999 then
                     begin
                      Inc(sk[i+1],sk[i] div 10000000);
                      sk[i] := sk[i] mod 10000000;
                     end;
 end;

procedure Strings_par_skaitli(s:string;var sk:skaitlis);
var
    l,i,count : byte;
    errcode,v_min : integer;
 begin
  sk := sk_0;
  l := Length(s);
  for i:=1 to ((l+6) div 7) do
   begin
    v_min := l - 7 * i + 1;
    count := 7;
    if v_min<1
     then
      begin
       v_min := 1;
       count := l-7*(i-1);
      end;
    Val(Copy(s,v_min,count),sk[i],errcode);
   end;
 end;

procedure Skaitlis_reiz(sk : skaitlis; b : byte; var sk_rez:skaitlis);
var i:byte;
 begin
  for i:=1 to 3 do sk_rez[i] := sk[i]*b;
  Normalize(sk_rez);
 end;

procedure Pakape(i,n : longint; var sk:skaitlis);
{Aprina sk := i ^ n}
var j:byte;
 begin
  sk[1] := i; sk[2] := 0; sk[3] := 0;
  for j := 2 to n do Skaitlis_reiz(sk,i,sk);
 end;

procedure Pieskaiti_skaitlim(var summa : skaitlis; piesk : skaitlis);
{ summa := summa + piesk }
var i:byte;
 begin
  for i:=1 to 3 do Inc(summa[i],piesk[i]);
  Normalize(summa);
 end;

function Armstrongs(s:string):byte;
var i,la,i_sak,i_bei:byte;
    sk_a,sk_b,sk_c,sk_s : skaitlis;
    c : array [0..9] of byte;
    s_tot : string;
 begin
  Armstrongs := 0;

  la := Length(s);
  if (la>max_garums) or (la=0) or (s[1]='0') then begin 
writeln('NEKOREKTI IEVADDATI'); Exit; end;

  {Vai korekts_skaitlis}
  for i:=0 to 9 do c[i] := 0;
  for i:=1 to la do
   case s[i] of
    '0' : Inc(c[0]);
    '1' : Inc(c[1]);
    '2' : Inc(c[2]);
    '3' : Inc(c[3]);
    '4' : Inc(c[4]);
    '5' : Inc(c[5]);
    '6' : Inc(c[6]);
    '7' : Inc(c[7]);
    '8' : Inc(c[8]);
    '9' : Inc(c[9]);
   end; {case}

  {Ja ciparu skaits nesakrt,tad ir bijis kds necipars}
  if (c[0]+c[1]+c[2]+c[3]+c[4]+c[5]+c[6]+c[7]+c[8]+c[9]<>la)
   then
    begin writeln('NEKOREKTI IEVADDATI'); Exit; end;

  Armstrongs := 2;

  Strings_par_skaitli(s,sk_a);

  sk_s := sk_0;
  sk_s[1] := c[1];

  for i:=2 to 9 do
   if c[i]>0
    then
     begin
      Pakape(i,la,sk_b);
      Skaitlis_reiz(sk_b,c[i],sk_c);
      Pieskaiti_skaitlim(sk_s,sk_c);
     end;

  for i:=1 to 3 do if sk_a[i]<>sk_s[i] then Exit;

  Armstrongs := 1;

 end;

begin
    Write ('Ievadiet virkni =>');    Readln(armstr_string);
    case Armstrongs(armstr_string) of
     0 : ; {Kda - nekas nav jdruk}
     1 : writeln(armstr_string,' IR ARMSTRONGA SKAITLIS');
     2 : writeln(armstr_string,' NAV ARMSTRONGA SKAITLIS');
    end; {case}
end.
