program taisnstura_lapas_locisana;

{Noskaidro, kdu laukumu noklj prlocta taisnstrveida lapa.

 c Mrti Opmanis, 1997}



 {$IFDEF WINDOWS} uses WinCrt; {$ENDIF}

 type punkts = record x,y : real; end;

 var
  a, b, xp, xq, z, lauk : real; {Tas, kas uzdevuma tekst ir x, te ir xp,
                                            tas, kas y - xq }
  ia,ib,ix,iy,iz : longint;
  punkti : array [1..5] of punkts;
  cik_punkti : byte;
  A_prim, B_prim : punkts; { Virsotu A un B projekcijas }

 label viss;

 function Trijstura_laukums(i1,i2,i3:byte):real;
  begin
   Trijstura_laukums :=
    ABS(
         punkti[i1].x * ( punkti[i2].y - punkti[i3].y ) +
         punkti[i2].x * ( punkti[i3].y - punkti[i1].y ) +
         punkti[i3].x * ( punkti[i1].y - punkti[i2].y ) ) / 2;

  end;  {Trijstura_laukums}

 function Aprekini_laukumu:real;
 var s : real;
  begin
   s := 0;
   if cik_punkti>2 then s := Trijstura_laukums(1,2,3);
   if cik_punkti>3 then s := s + Trijstura_laukums(1,3,4);
   if cik_punkti>4 then s := s + Trijstura_laukums(1,4,5);
   Aprekini_laukumu := s;
  end;  {Aprekini_laukumu}


 begin
  Writeln('Ievadiet a(0<a<=1000),b(0<b<=1000),x(0<=x<=a),y(0<=y<=a) !');
  Readln(ia,ib,ix,iy);

  {Normaliz}
  if ix<iy then begin iz:=ix; ix:=iy; iy:=iz; end;
  if ix>ia-iy then begin iz:=ia-iy; iy:=ia-ix; ix:=iz; end;

  a:=ia; b:=ib; xp:=ix; xq:=iy;

  if ix=iy then begin lauk:=xp*b; goto viss; end;

  cik_punkti := 1;
  with punkti[cik_punkti] do begin x:=xq; y:=0; end;  {Q}
  Inc(cik_punkti);
  with punkti[cik_punkti] do begin x:=xp; y:=b; end;  {P}

  {Atrod B' un A' koordintes}
  z := 2*b*b/(b*b+(xp-xq)*(xp-xq));
  with B_prim do begin x:=xp*z; y:=(xq-xp)/b*x+b; end;
  with A_prim do begin x:=xq*z; y:=(xq-xp)/b*x; end;

  if (B_prim.x<=a) and (B_prim.y>=0)
   then {B' atrodas ABCD iekpus}
    begin
     {Pievieno B' luma virsotu sarakstam}
     Inc(cik_punkti);
     punkti[cik_punkti] := B_prim;
     if iy<>0
      then
       begin  {Mekl A'B' krustpunktu ar QD}
        Inc(cik_punkti);
        with punkti[cik_punkti] do
         begin
          x:=(A_prim.x*B_prim.y-A_prim.y*B_prim.x)/(B_prim.y-A_prim.y);
          y:=0;
         end;
       end;
     lauk := Aprekini_laukumu;
     goto viss;
    end;

  if B_prim.x>a
   then {Bs piecstris}
    begin
     Inc(cik_punkti);
     with punkti[cik_punkti] do
      begin
       x:=a;
       y:=b+(a-xp)*(B_prim.y-b)/(B_prim.x-xp);
      end;
     Inc(cik_punkti);
     with punkti[cik_punkti] do
      begin
       x:=a;
       y:=A_prim.y+(a-A_Prim.x)*(B_prim.y-A_prim.y)/(B_prim.x-A_prim.x);
      end;
     Inc(cik_punkti);
     with punkti[cik_punkti] do
      begin
       x:=(A_prim.x*B_prim.y-A_prim.y*B_prim.x)/(B_prim.y-A_prim.y);
       y:=0;
      end;
     lauk := Aprekini_laukumu;
     goto viss;
    end;

    if B_prim.y<0 then
     begin
      Inc(cik_punkti);
      with punkti[cik_punkti] do
       begin
        x:=xp+(B_prim.x-xp)*b/(b-B_prim.y);
        y:=0;
       end;
      lauk := Aprekini_laukumu;
      goto viss;
     end;

     viss : writeln((a*b-lauk):15:6);

end.



